------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--                                                                                      --
--                          ||       ||   ||       ||||     |||||    ||||               --
--                         ||||      ||  ||       || ||    ||   ||  || ||               --
--                        ||  ||     || ||           ||   ||     ||    ||               --
--                       ||||||||    ||||            ||   ||     ||    ||               --
--                      ||      ||   || ||           ||   ||     ||    ||               --
--                     ||        ||  ||  ||          ||    ||   ||     ||               --
--                    ||          || ||   ||      |||||||   |||||   |||||||             --
--                                                                                      --
------------------------------------------------------------------------------------------
--																						--
--						  	 		   > [Functions]									--
--									   > [Arrays]		   								--
--									   > [Override]				    					--
--									   > [Adds] 										--
--									   > [Forbids] 										--
--									   > [Stance]										--
--									   > [Underbarrel] 							    	--
--									   > [Tweaks] 										--
--									   > [WIP] 											--
--																						--
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------


---------------------------------------------------
----<A><K><1><0><1> -Functions- <A><K><1><0><1>----
---------------------------------------------------

--- Forbid Setup ---
function WeaponFactoryTweakData:akpack_setup_forbid( mod_one, mod_two )
	if self.parts[mod_one] and self.parts[mod_two] then
		self.parts[mod_one].forbids = self.parts[mod_one].forbids or {}
		table.insert(self.parts[mod_one].forbids, mod_two)
		self.parts[mod_two].forbids = self.parts[mod_two].forbids or {}
		table.insert(self.parts[mod_two].forbids, mod_one)
	else
		if not self.parts[mod_one] then
			self:akpack_write_error( "forbid_setup", "fti", "part", mod_two )	
		end
		if not self.parts[mod_two] then
			self:akpack_write_error( "forbid_setup", "fti", "part", mod_two )	
		end
	end
end

--- Override Base ---
function WeaponFactoryTweakData:akpack_check_override( mod_type, mod_woa ) 
	if mod_type == "wpn" then
		if self[mod_woa] then
			self[mod_woa].override = self[mod_woa].override or {}
		else 
			self:akpack_write_error( "override_check", "fti", mod_type, mod_woa )
		end
	elseif mod_type == "part" then
		if self.parts[mod_woa] then
			self.parts[mod_woa].override = self.parts[mod_woa].override or {}
		else 
			self:akpack_write_error( "override_check", "fti", mod_type, mod_woa )
		end
	else
		self:akpack_write_error( "override_check", "fti", "mod_type", mod_type )
	end
end

--- Adds Base ---
function WeaponFactoryTweakData:akpack_check_adds( mod_type, mod_woa ) 
	if mod_type == "wpn" then
		if self[mod_woa] then
			self[mod_woa].adds = self[mod_woa].adds or {}
		else 
			self:akpack_write_error( "adds_check", "fti", mod_type, mod_woa )
		end
	elseif mod_type == "part" then
		if self.parts[mod_woa] then
			self.parts[mod_woa].adds = self.parts[mod_woa].adds or {}
		else 
			self:akpack_write_error( "adds_check", "fti", mod_type, mod_woa )
		end
	else
		self:akpack_write_error( "adds_check", "fti", "mod_type", mod_type )
	end
end

--- Part Copy Base ---
function WeaponFactoryTweakData:ak556_copy_part( att_og, att_cp )
    if self.parts[att_og] then
        self.parts[att_cp] = deep_clone(self.parts[att_og])
        self.parts[att_cp].pcs = {}
        self.parts[att_cp].is_a_unlockable = true
        table.insert(self.wpn_fps_ass_heffy_556.uses_parts, att_cp)
    else
        self:akpack_write_error( "copy_part", "fti", "part", att_og )    
    end
end

--- ERROR Base ---
function WeaponFactoryTweakData:akpack_write_error( func, cause, error_id, value  )
	if func and cause and error_id then 
		-- fti = failed to index
		if cause == "fti" and value then
			if error_id == "part" then
				log("AK101_ERROR: (" .. func .. ")Attempt to index Part ID: '" .. value .. "' (a nil value)")
			elseif error_id == "wpn" then
				log("AK101_ERROR: (" .. func .. ")Attempt to index Weapon ID: '" .. value .. "' (a nil value)")
			elseif error_id == "mod_type" then
				log("AK101_ERROR: (" .. func .. ")Attempt to index mod_type: '" .. value .. "' (a nil value)")
			end
		end
	end
end 

Hooks:PostHook( WeaponFactoryTweakData, "init", "AK101ModInit", function(self)

------------------------------------------------
----<A><K><1><0><1> -Arrays- <A><K><1><0><1>----
------------------------------------------------

--- Stocks ---
all_ak101stock = {
	"wpn_fps_ass_heffy_556_st_ak101"
}
ak101stock = {
	"wpn_fps_ass_heffy_556_st_ak101"
}
--- Stock Pads ---
ak101stockpad = {
	"wpn_fps_ass_heffy_556_stp_ak101",
	"wpn_fps_ass_heffy_556_stp2_ak101"
}
--- Fore Grip ---
-- Default length --
all_ak101lfg = {
	"wpn_fps_ass_heffy_556_lfg_ak101"
}
all_ak101ufg = {
	"wpn_fps_ass_heffy_556_ufg_ak101"
}
ak101foregrip = {
	"wpn_fps_ass_heffy_556_lfg_ak101"
}

--- Barrel ---
-- Default length --
ak101barrel = {
	"wpn_fps_ass_heffy_556_ba_ak101",
	"wpn_fps_ass_heffy_556_ba_ak108"
}
all_ak101barrel = {
	"wpn_fps_ass_heffy_556_ba_ak101",
	"wpn_fps_ass_heffy_556_ba_ak102",
	"wpn_fps_ass_heffy_556_ba_ak108"
}

--- Front Sights ---
all_ak101fo = {
	"wpn_fps_ass_heffy_556_fo_ak101"
}

--- Barrel Extensions --
all_ak101ext = {
	"wpn_fps_upg_ns_ass_smg_large",
	"wpn_fps_upg_ns_ass_smg_medium",
	"wpn_fps_upg_ns_ass_smg_small",
	"wpn_fps_upg_ns_ass_smg_firepig",
	"wpn_fps_upg_ns_ass_smg_stubby",
	"wpn_fps_upg_ns_ass_smg_tank",
	"wpn_fps_upg_ns_ass_pbs1",
	"wpn_fps_upg_ass_ns_jprifles",
	"wpn_fps_upg_ass_ns_linear",
	"wpn_fps_upg_ass_ns_surefire",
	"wpn_fps_upg_ass_ns_battle",
	"wpn_fps_ass_heffy_556_fh_dummy",
	"wpn_fps_ass_heffy_556_fh_ak101",
	"wpn_fps_ass_heffy_556_fh_ak102",
	"wpn_fps_ass_heffy_556_fh_ak108"
}

--- Gadgets (Flashlights/Lasers) ---
all_ak101fl = {
	"wpn_fps_upg_fl_ass_smg_sho_peqbox",
	"wpn_fps_upg_fl_ass_smg_sho_surefire",
	"wpn_fps_upg_fl_ass_peq15",
	"wpn_fps_upg_fl_ass_laser",
	"wpn_fps_upg_fl_ass_utg",
	"wpn_fps_addon_ris"
}

--- Sights ---
all_ak101sight = {
	"wpn_fps_upg_o_specter",
	"wpn_fps_upg_o_aimpoint",
	"wpn_fps_upg_o_aimpoint_2",
	"wpn_fps_upg_o_docter",
	"wpn_fps_upg_o_eotech",
	"wpn_fps_upg_o_t1micro",
	"wpn_fps_upg_o_cmore",
	"wpn_fps_upg_o_acog",
	"wpn_fps_upg_o_cs",
	"wpn_fps_upg_o_eotech_xps",
	"wpn_fps_upg_o_reflex",
	"wpn_fps_upg_o_rx01",
	"wpn_fps_upg_o_rx30",
	"wpn_fps_upg_o_spot"
}
local vanilla_ak101sight = {
	"wpn_fps_upg_o_specter",
	"wpn_fps_upg_o_aimpoint",
	"wpn_fps_upg_o_aimpoint_2",
	"wpn_fps_upg_o_docter",
	"wpn_fps_upg_o_eotech",
	"wpn_fps_upg_o_t1micro",
	"wpn_fps_upg_o_cmore",
	"wpn_fps_upg_o_acog",
	"wpn_fps_upg_o_cs",
	"wpn_fps_upg_o_eotech_xps",
	"wpn_fps_upg_o_reflex",
	"wpn_fps_upg_o_rx01",
	"wpn_fps_upg_o_rx30",
	"wpn_fps_upg_o_spot"
}

--- Lower ---
all_ak101lower = {
	"wpn_fps_ass_heffy_556_lr_ak101",
	"wpn_fps_ass_heffy_556_lr_t84s"
}

--- Grips ---
ak101grips = {
	"wpn_fps_ass_heffy_556_pg_ak101"
}
ak101akmgrips = {
	"wpn_fps_ass_heffy_556_pg_t84s"
}

--- CAFCW aka better later then never also holy shit this actually works ---
if attach_tables then
	for _, md_id in pairs(attach_tables.Barrel_Extensions) do
		if self.parts[md_id] then
			table.insert(all_ak101ext, md_id)
		end
	end
	for _, md_id in pairs(attach_tables.Suppressors) do
		if self.parts[md_id] then
			table.insert(all_ak101ext, md_id)
		end
	end
	for _, fl_id in pairs(attach_tables.Gadgets) do
		if self.parts[fl_id] then
			table.insert(all_ak101fl, fl_id)
		end
	end
	for _, o_id in pairs(attach_tables.ACOG) do
		if self.parts[o_id] then
			table.insert(all_ak101sight, o_id)
		end
	end
	for _, o_id in pairs(attach_tables.Custom) do
		if self.parts[o_id] then
			table.insert(all_ak101sight, o_id)
		end
	end
	for _, o_id in pairs(attach_tables.Specter) do
		if self.parts[o_id] then
			table.insert(all_ak101sight, o_id)
		end
	end
	if attach_tables.Custom_AK then --safety (since that thing doesn't exist in older versions)
		for _, o_id in pairs(attach_tables.Custom_AK) do
			if self.parts[o_id] then
				table.insert(self.parts.wpn_fps_upg_o_ak101_l_scopemount.forbids, o_id)
			end
		end
	end
end
--- Compatibility Array Insertion ---

if self.wpn_fps_ass_heffy_762 then

	for id, part_id in pairs(heffy762stocks) do
		if part_id ~= "wpn_fps_ass_heffy_all_st_ak47" and part_id ~= "wpn_fps_ass_heffy_762_st_ak103" then
			self.parts.wpn_fps_ass_heffy_556_lr_ak101.override[part_id] = {a_obj="a_s_akmsu"}
		elseif part_id == "wpn_fps_ass_heffy_all_st_ak47" then
			self.parts.wpn_fps_ass_heffy_556_lr_ak101.override[part_id] = {a_obj="a_s_akmsu_ak47"}
		end
	end
		
	for id, part_id in pairs(heffy762stockparts) do
		if part_id ~= "wpn_fps_ass_heffy_762_sp_ak47" then
			self.parts.wpn_fps_ass_heffy_556_lr_ak101.override[part_id] = {a_obj="a_s_akmsu"}
		else
			self.parts.wpn_fps_ass_heffy_556_lr_ak101.override[part_id] = {a_obj="a_s_akmsu_ak47"}
		end
	end
	table.insert(ak101akmgrips, "wpn_fps_ass_heffy_all_pg_ak47")
	table.insert(ak101akmgrips, "wpn_fps_ass_heffy_762_pg_t2")
end

-----------------------------------------
----<A><K><4><7> -CAFCW- <A><K><4><7>----
-----------------------------------------

if BeardLib.Utils:FindMod("M82 Muzzle Brake") then
	table.insert(all_ak101ext, "wpn_fps_upg_ns_m82")
	table.insert(all_ak101ext, "wpn_fps_upg_ns_aw50")
end
if self.parts.wpn_fps_upg_o_thersig then
	table.insert(all_ak101sight, "wpn_fps_upg_o_thersig")
	table.insert(vanilla_ak101sight, "wpn_fps_upg_o_thersig")
end
--------------------------------------------------
----<A><K><1><0><1> -Override- <A><K><1><0><1>----
--------------------------------------------------

--- Gun ---

--- Barrel ---
for id, ba_id in pairs(all_ak101barrel) do
	self:akpack_check_override( "part", ba_id )
end
--self.parts.wpn_fps_ass_heffy_762_ba_akm.override.wpn_fps_ass_heffy_762_fh_dummy = {unit="units/mods/weapons/wpn_fps_ass_heffy_762_akm_pts/wpn_fps_ass_heffy_762_fh_akm"}
-- Default length barrel barrel extension and front sight override --
for id, ba_id in pairs(ak101barrel) do
	for id, ext_id in pairs(all_ak101ext) do
		if ext_id ~= "wpn_fps_ass_heffy_556_fh_dummy" then
			self.parts[ba_id].override[ext_id] = {a_obj = "a_ns"}
		end
	end
	for id, fo_id in pairs(all_ak101fo) do
		self.parts[ba_id].override[fo_id] = {}
	end
end

-- Other length barrel barrel extension overrides --
for id, ext_id in pairs(all_ak101ext) do
	if ext_id == "wpn_fps_ass_heffy_556_fh_dummy" then
		self.parts.wpn_fps_ass_heffy_556_ba_ak102.override[ext_id] = {a_obj = "a_ns_ak102", unit="units/mods/weapons/wpn_fps_ass_heffy_556_ak102_pts/wpn_fps_ass_heffy_556_fh_ak102"}
		self.parts.wpn_fps_ass_heffy_556_ba_t84s_long.override[ext_id] = {a_obj = "a_ns_t84s", unit="units/mods/weapons/wpn_fps_ass_heffy_556_t84s_pts/wpn_fps_ass_heffy_556_fh_t84s"}
	else
		self.parts.wpn_fps_ass_heffy_556_ba_ak102.override[ext_id]	= {a_obj = "a_ns_ak102"}
		self.parts.wpn_fps_ass_heffy_556_ba_t84s_long.override[ext_id]	= {a_obj = "a_ns_t84s"}
	end
end
-- Other length barrel Front Sight overrides --
for id, fo_id in pairs(all_ak101fo) do
	self.parts.wpn_fps_ass_heffy_556_ba_ak102.override[fo_id] = {a_obj = "a_fo_ak102"}
	self.parts.wpn_fps_ass_heffy_556_ba_t84s_long.override[fo_id] = {a_obj = "a_fo_t84s"}
end

--- Receiver aka Lower ---
for i, lr_id in pairs(all_ak101lower) do
	for _, pg_id in pairs(ak101akmgrips) do
		self.parts[lr_id].override[pg_id] = {a_obj="a_g_akm"}
	end
end
----------------------------------------------
----<A><K><1><0><1> -Adds- <A><K><1><0><1>----
----------------------------------------------
--- Gun ---
self:akpack_check_adds( "wpn", "wpn_fps_ass_heffy_556" )
for id, o_id in pairs(vanilla_ak101sight) do
	self.wpn_fps_ass_heffy_556.adds[o_id] = {"wpn_fps_upg_o_ak101_scopemount"}
end
	
-------------------------------------------------
----<A><K><1><0><1> -Forbids- <A><K><1><0><1>----
-------------------------------------------------

------------------------------------------------
----<A><K><1><0><1> -Stance- <A><K><1><0><1>----
------------------------------------------------

--- Vanilla sights ---
for id, o_id in pairs(vanilla_ak101sight) do
	if self.parts[o_id].stance_mod.wpn_fps_ass_flint then
		self.parts[o_id].stance_mod.wpn_fps_ass_heffy_556 = deep_clone(self.parts[o_id].stance_mod.wpn_fps_ass_flint)
	else
		log("[AK_Pack] [ERROR] WHO THE FUCK MESSED WITH SIGHT STANCES THIS TIME!? " .. o_id)
	end
end
-----------------------------------------------------
----<A><K><1><0><1> -Underbarrel- <A><K><1><0><1>----
-----------------------------------------------------

------------------------------------------------
----<A><K><1><0><1> -Tweaks- <A><K><1><0><1>----
------------------------------------------------

--- Barrel Extensions ---
self.parts.wpn_fps_ass_heffy_556_fh_dummy.pcs = nil

------------------------------------------------
----<A><K><1><0><1> -CLONES- <A><K><1><0><1>----
------------------------------------------------

self:akpack_check_override( "wpn", "wpn_fps_ass_heffy_556" )

if self.parts.wpn_fps_ass_heffy_all_fc_pg_poly_pl and self.wpn_fps_ass_heffy_762 or self.wpn_fps_ass_heffy_545 then

	local akwoodcolors = {
		"wpn_fps_ass_heffy_all_fc_fg_wood_red",
		"wpn_fps_ass_heffy_all_fc_pg_wood_red",
		"wpn_fps_ass_heffy_all_fc_st_wood_red",
		"wpn_fps_ass_heffy_all_fc_fg_wood_ora",
		"wpn_fps_ass_heffy_all_fc_pg_wood_ora",
		"wpn_fps_ass_heffy_all_fc_st_wood_ora",
		"wpn_fps_ass_heffy_all_fc_fg_wood_lac",
		"wpn_fps_ass_heffy_all_fc_pg_wood_lac",
		"wpn_fps_ass_heffy_all_fc_st_wood_lac",
	}

	for id, part_id in pairs (akwoodcolors) do
		table.insert(self.wpn_fps_ass_heffy_556.uses_parts, part_id)
	end
		
end

---------------------------------------------
----<A><K><1><0><1> -WIP- <A><K><1><0><1>----
---------------------------------------------

---- Override ----


--- Gadget positions ---
--[[ 
for id, part_id in pairs(all_ak47fl) do
	self.parts.wpn_fps_ass_heffy_762_flp_<insert_flashlight_position_name>.override[part_id] = {a_obj = "a_fl_ak47"}
end
--]]
end )

